const express=require('express'); // 함수를 반환
const router=express.Router(); // app객체처럼 router객체를 반환
const Template=require('../lib/Template');

module.exports=function(passport){
  
  // 클라이언트에서 입력한 데이터를 처리하는 경우 <로그인 처리>
  // 사용자가 login-submit을 통해 서버에 데이터를 전송했을 때 (응답 코드)

  /*  process_login으로 들어오면 local방식의 passport API로 처리
      local방식은 id와 pw를 이용해서 로그인하는 것 (sns계정 이용x) */
  router.post('/process_login',
    passport.authenticate('local',{failureRedirect: '/page/login' /* 로그인 실패 */}),
    // 로그인 성공하면 아래 함수 호출
    function(request, response) {
      request.session.save(()=>{ response.redirect('/');});
    }
  );

  // 클라이언트에서 입력했던 데이터를 처리하는 경우 <로그아웃 처리>
  // 사용자가 Logout을 통해 서버에 데이터를 전송했을 때 (응답 코드)
  router.get('/process_logout',(request,response)=>{
    if(request.user===undefined){
      response.send(Template.LOGIN());
      return false;
    }
    request.logout(); // passport API가 알아서 세션 파일에서 user 삭제, request.user 삭제
    request.session.save(()=>{ response.redirect('/'); });
  });

  return router;
}
